var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.runAndroidLog=exports.configureAndroidProperties=exports.runAndroid=exports.packageAndroid=exports.listAndroidTargets=exports.buildAndroid=exports.launchAndroidSimulator=exports.configureGradleProject=exports.copyAndroidAssets=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _defineProperty2=_interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));var _slicedToArray2=_interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _path=_interopRequireDefault(require("path"));
var _os=_interopRequireDefault(require("os"));
var _fs=_interopRequireDefault(require("fs"));
var _net=_interopRequireDefault(require("net"));
var _chalk=_interopRequireDefault(require("chalk"));
var _shelljs=_interopRequireDefault(require("shelljs"));
var _child_process=_interopRequireDefault(require("child_process"));
var _inquirer=_interopRequireDefault(require("inquirer"));

var _exec=require("../systemTools/exec");
var _platform=require("../cli/platform");
var _common=require("../common");

























var _fileutils=require("../systemTools/fileutils");
var _constants=require("../constants");
var _pluginTools=require("../pluginTools");function _objectSpread(target){for(var i=1;i<arguments.length;i++){if(i%2){var source=arguments[i]!=null?arguments[i]:{};var ownKeys=Object.keys(source);if(typeof Object.getOwnPropertySymbols==='function'){ownKeys=ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym){return Object.getOwnPropertyDescriptor(source,sym).enumerable;}));}ownKeys.forEach(function(key){(0,_defineProperty2.default)(target,key,source[key]);});}else{Object.defineProperties(target,Object.getOwnPropertyDescriptors(arguments[i]));}}return target;}

var readline=require('readline');

var CHECK_INTEVAL=5000;

var currentDeviceProps=null;

var composeDevicesString=function composeDevicesString(devices,returnArray){
(0,_common.logTask)("composeDevicesString:"+(devices?devices.length:null));
var devicesArray=[];
devices.forEach(function(v,i){return devicesArray.push(_getDeviceString(v,!returnArray?i:null));});
if(returnArray)return devicesArray;
return"\n"+devicesArray.join('');
};

var launchAndroidSimulator=function launchAndroidSimulator(c,platform,target){var isIndependentThread=arguments.length>3&&arguments[3]!==undefined?arguments[3]:false;
(0,_common.logTask)("launchAndroidSimulator:"+platform+":"+target);

if(target==='?'||target===undefined||target===''){
return _listAndroidTargets(c,true,false,false).
then(function(devicesArr){
var devicesString=composeDevicesString(devicesArr);
var readlineInterface=readline.createInterface({
input:process.stdin,
output:process.stdout});

readlineInterface.question((0,_common.getQuestion)(devicesString+"\nType number of the emulator you want to launch"),function(v){
var selectedDevice=devicesArr[parseInt(v,10)-1];
if(selectedDevice){
if(isIndependentThread){
(0,_exec.execCLI)(c,_common.CLI_ANDROID_EMULATOR,"-avd \""+selectedDevice.name+"\"").catch(_common.logError);
return Promise.resolve();
}
return(0,_exec.execCLI)(c,_common.CLI_ANDROID_EMULATOR,"-avd \""+selectedDevice.name+"\"");
}
(0,_common.logError)("Wrong choice "+v+"! Ingoring");
});
});
}

if(target){
var actualTarget=target.name||target;
if(isIndependentThread){
(0,_exec.execCLI)(c,_common.CLI_ANDROID_EMULATOR,"-avd \""+actualTarget+"\"").catch(_common.logError);
return Promise.resolve();
}
return(0,_exec.execCLI)(c,_common.CLI_ANDROID_EMULATOR,"-avd \""+actualTarget+"\"");
}
return Promise.reject('No simulator -t target name specified!');
};exports.launchAndroidSimulator=launchAndroidSimulator;

var listAndroidTargets=function listAndroidTargets(c){
(0,_common.logTask)('listAndroidTargets');var
device=c.program.device;
return _listAndroidTargets(c,false,device,device).then(function(list){return composeDevicesString(list);}).then(function(devices){
console.log(devices);
if(devices.trim()==='')console.log('No devices found');
return devices;
});
};exports.listAndroidTargets=listAndroidTargets;

var _getDeviceString=function _getDeviceString(device,i){var

isTV=
device.isTV,isTablet=device.isTablet,name=device.name,udid=device.udid,isDevice=device.isDevice,isActive=device.isActive,avdConfig=device.avdConfig,isWear=device.isWear,arch=device.arch;
var deviceIcon='';
if(isTablet)deviceIcon='Tablet 💊 ';
if(isTV)deviceIcon='TV 📺 ';
if(isWear)deviceIcon='Wear ⌚ ';
if(!deviceIcon&&(udid!=='unknown'||avdConfig))deviceIcon='Phone 📱 ';

var deviceString=_chalk.default.white(name)+" | "+deviceIcon+" | arch: "+arch+" | udid: "+_chalk.default.blue(udid)+(isDevice?_chalk.default.red(' (device)'):'')+" "+(
isActive?_chalk.default.magenta(' (active)'):'');

if(i===null)return{key:name,name:deviceString,value:name};

return"-["+(i+1)+"] "+deviceString+"\n";
};

var _listAndroidTargets=function _listAndroidTargets(c,skipDevices,skipAvds){var deviceOnly=arguments.length>3&&arguments[3]!==undefined?arguments[3]:false;
(0,_common.logTask)("_listAndroidTargets:"+c.platform+":"+skipDevices+":"+skipAvds+":"+deviceOnly);
try{
var devicesResult;
var avdResult;

if(!skipDevices){
devicesResult=_child_process.default.execSync(c.cli[_common.CLI_ANDROID_ADB]+" devices -l").toString();
(0,_common.logDebug)(c.cli[_common.CLI_ANDROID_ADB]+" devices -l",devicesResult);
}
if(!skipAvds){
avdResult=_child_process.default.execSync(c.cli[_common.CLI_ANDROID_EMULATOR]+" -list-avds").toString();
(0,_common.logDebug)(c.cli[_common.CLI_ANDROID_EMULATOR]+" -list-avds",avdResult);
}
return _parseDevicesResult(devicesResult,avdResult,deviceOnly,c);
}catch(e){
return Promise.reject(e);
}
};

var calculateDeviceDiagonal=function calculateDeviceDiagonal(width,height,density){

var widthInches=width/density;
var heightInches=height/density;
return Math.sqrt(widthInches*widthInches+heightInches*heightInches);
};

var isSquareishDevice=function isSquareishDevice(width,height){
var ratio=width/height;
if(ratio>0.8&&ratio<1.2)return true;
return false;
};

var getRunningDeviceProp=function getRunningDeviceProp(c,udid,prop){

if(currentDeviceProps){
if(!prop)return currentDeviceProps;
return currentDeviceProps[prop];
}
var rawProps=_child_process.default.execSync(c.cli[_common.CLI_ANDROID_ADB]+" -s "+udid+" shell getprop").toString().trim();
var reg=/\[.+\]: \[.*\n?[^\[]*\]/gm;
var lines=rawProps.match(reg);

lines.forEach(function(line){
var words=line.split(']: [');
var key=words[0].slice(1);
var value=words[1].slice(0,words[1].length-1);

if(!currentDeviceProps)currentDeviceProps={};
currentDeviceProps[key]=value;
});

return getRunningDeviceProp(c,udid,prop);
};

var decideIfTV=function decideIfTV(c,udid){
var model=getRunningDeviceProp(c,udid,'ro.product.model');
var name=getRunningDeviceProp(c,udid,'ro.product.name');
var flavor=getRunningDeviceProp(c,udid,'ro.build.flavor');
var description=getRunningDeviceProp(c,udid,'ro.build.description');

if(model.toLowerCase().includes('atv')||name.toLowerCase().includes('atv')||flavor.toLowerCase().includes('atv')||description.toLowerCase().includes('atv'))return true;
if(model.includes('SHIELD'))return true;
return false;
};

var getDeviceType=function getDeviceType(device,c){var screenSizeResult,screenDensityResult,arch,screenProps,_screenSizeResult$spl,_screenSizeResult$spl2,width,height,density,_screenProps,_width,_height,_density,diagonalInches,_density2,_width2,_height2,_arch,sysdir,tagId,tagDisplay,deviceName,avdId,name,skin,image,_diagonalInches;return _regenerator.default.async(function getDeviceType$(_context){while(1){switch(_context.prev=_context.next){case 0:
(0,_common.logDebug)('getDeviceType - in',{device:device});if(!(
device.udid!=='unknown')){_context.next=15;break;}
screenSizeResult=_child_process.default.execSync(c.cli[_common.CLI_ANDROID_ADB]+" -s "+device.udid+" shell wm size").toString();
screenDensityResult=_child_process.default.execSync(c.cli[_common.CLI_ANDROID_ADB]+" -s "+device.udid+" shell wm density").toString();
arch=getRunningDeviceProp(c,device.udid,'ro.product.cpu.abi');


if(screenSizeResult){_screenSizeResult$spl=
screenSizeResult.split('Physical size: ')[1].split('x'),_screenSizeResult$spl2=(0,_slicedToArray2.default)(_screenSizeResult$spl,2),width=_screenSizeResult$spl2[0],height=_screenSizeResult$spl2[1];
screenProps={width:parseInt(width,10),height:parseInt(height,10)};
}

if(screenDensityResult){
density=screenDensityResult.split('Physical density: ')[1];
screenProps=_objectSpread({},screenProps,{density:parseInt(density,10)});
}

device.isTV=decideIfTV(c,device.udid);

if(screenSizeResult&&screenDensityResult){_screenProps=
screenProps,_width=_screenProps.width,_height=_screenProps.height,_density=_screenProps.density;

diagonalInches=calculateDeviceDiagonal(_width,_height,_density);
screenProps=_objectSpread({},screenProps,{diagonalInches:diagonalInches});
device.isTablet=!device.isTV&&diagonalInches>_constants.IS_TABLET_ABOVE_INCH&&diagonalInches<=15;
device.isWear=isSquareishDevice(_width,_height);
}

device.isPhone=!device.isTablet&&!device.isWear&&!device.isTV;
device.isMobile=!device.isWear&&!device.isTV;
device.screenProps=screenProps;
device.arch=arch;
(0,_common.logDebug)('getDeviceType - out',{device:device});return _context.abrupt("return",
device);case 15:if(!


device.avdConfig){_context.next=39;break;}
_density2=parseInt(device.avdConfig['hw.lcd.density'],10);
_width2=parseInt(device.avdConfig['hw.lcd.width'],10);
_height2=parseInt(device.avdConfig['hw.lcd.height'],10);
_arch=device.avdConfig['abi.type'];


sysdir=device.avdConfig['image.sysdir.1'];
tagId=device.avdConfig['tag.id'];
tagDisplay=device.avdConfig['tag.display'];
deviceName=device.avdConfig['hw.device.name'];

device.isWear=false;
[sysdir,tagId,tagDisplay,deviceName].forEach(function(string){
if(string&&string.includes('wear'))device.isWear=true;
});

avdId=device.avdConfig.AvdId;
name=device.avdConfig['hw.device.name'];
skin=device.avdConfig['skin.name'];
image=device.avdConfig['image.sysdir.1'];

device.isTV=false;
[avdId,name,skin,image].forEach(function(string){
if(string&&string.toLowerCase().includes('tv'))device.isTV=true;
});

_diagonalInches=calculateDeviceDiagonal(_width2,_height2,_density2);
device.isTablet=!device.isTV&&_diagonalInches>_constants.IS_TABLET_ABOVE_INCH;
device.isPhone=!device.isTablet&&!device.isWear&&!device.isTV;
device.isMobile=!device.isWear&&!device.isTV;
device.arch=_arch;
(0,_common.logDebug)('getDeviceType - out',{device:device});return _context.abrupt("return",
device);case 39:return _context.abrupt("return",

device);case 40:case"end":return _context.stop();}}});};


var getAvdDetails=function getAvdDetails(c,deviceName){var _process$env=
process.env,ANDROID_SDK_HOME=_process$env.ANDROID_SDK_HOME,ANDROID_AVD_HOME=_process$env.ANDROID_AVD_HOME;


var avdConfigPaths=[""+
ANDROID_AVD_HOME,
ANDROID_SDK_HOME+"/.android/avd",
_os.default.homedir()+"/.android/avd"];


var results={};

avdConfigPaths.forEach(function(cPath){
if(_fs.default.existsSync(cPath)){
var filesPath=_fs.default.readdirSync(cPath);


filesPath.forEach(function(fName){
var fPath=_path.default.join(cPath,fName);
var dirent=_fs.default.lstatSync(fPath);
if(!dirent.isDirectory()&&fName===deviceName+".ini"){
var avdData=_fs.default.readFileSync(fPath).toString();
var lines=avdData.trim().split(/\r?\n/);
lines.forEach(function(line){var _line$split=
line.split('='),_line$split2=(0,_slicedToArray2.default)(_line$split,2),key=_line$split2[0],value=_line$split2[1];
if(key==='path'){
var initData=_fs.default.readFileSync(value+"/config.ini").toString();
var initLines=initData.trim().split(/\r?\n/);
var avdConfig={};
initLines.forEach(function(initLine){var _initLine$split=
initLine.split('='),_initLine$split2=(0,_slicedToArray2.default)(_initLine$split,2),iniKey=_initLine$split2[0],iniValue=_initLine$split2[1];

avdConfig[iniKey.trim()]=iniValue.trim();
});
results.avdConfig=avdConfig;
}
});
}
});
}
});
return results;
};

var getEmulatorName=function getEmulatorName(words){var emulator,port,command,emulatorReply,emulatorReplyArray,emulatorName;return _regenerator.default.async(function getEmulatorName$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:
emulator=words[0];
port=emulator.split('-')[1];

command=(0,_exec.commandExistsSync)('nc')?'nc':null;
if((0,_exec.commandExistsSync)('telnet'))command='telnet';if(

command){_context2.next=6;break;}throw new Error('You must have nc or telnet installed');case 6:_context2.next=8;return _regenerator.default.awrap(

(0,_exec.execCLI)(null,null,"echo \"avd name\" | "+command+" localhost "+port));case 8:emulatorReply=_context2.sent;
emulatorReplyArray=emulatorReply.split('OK');
emulatorName=emulatorReplyArray[emulatorReplyArray.length-2].trim();return _context2.abrupt("return",
emulatorName);case 12:case"end":return _context2.stop();}}});};


var connectToWifiDevice=function connectToWifiDevice(c,ip){var deviceResponse;return _regenerator.default.async(function connectToWifiDevice$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:
deviceResponse=_child_process.default.execSync(c.cli[_common.CLI_ANDROID_ADB]+" connect "+ip+":5555").toString();if(!
deviceResponse.includes('connected')){_context3.next=3;break;}return _context3.abrupt("return",true);case 3:
(0,_common.logError)("Failed to connect to "+ip+":5555");return _context3.abrupt("return",
false);case 5:case"end":return _context3.stop();}}});};


var _parseDevicesResult=function _parseDevicesResult(devicesString,avdsString,deviceOnly,c){var devices,lines,avdLines;return _regenerator.default.async(function _parseDevicesResult$(_context6){while(1){switch(_context6.prev=_context6.next){case 0:
(0,_common.logDebug)("_parseDevicesResult:"+devicesString+":"+avdsString+":"+deviceOnly);
devices=[];if(!

devicesString){_context6.next=8;break;}
lines=devicesString.trim().split(/\r?\n/);
(0,_common.logDebug)('_parseDevicesResult',{lines:lines});if(!(
lines.length!==0)){_context6.next=8;break;}_context6.next=8;return _regenerator.default.awrap(
Promise.all(lines.map(function _callee(line){var words,isDevice,_name;return _regenerator.default.async(function _callee$(_context4){while(1){switch(_context4.prev=_context4.next){case 0:
words=line.split(/[ ,\t]+/).filter(function(w){return w!=='';});if(!(
words.length===0)){_context4.next=3;break;}return _context4.abrupt("return");case 3:
(0,_common.logDebug)('_parseDevicesResult',{words:words});if(!(

words[1]==='device')){_context4.next=18;break;}
isDevice=!words[0].includes('emulator');
_name=_getDeviceProp(words,'model:');
(0,_common.logDebug)('_parseDevicesResult',{name:_name});if(
isDevice){_context4.next=15;break;}_context4.next=11;return _regenerator.default.awrap(
waitForEmulatorToBeReady(c,words[0]));case 11:_context4.next=13;return _regenerator.default.awrap(
getEmulatorName(words));case 13:_name=_context4.sent;
(0,_common.logDebug)('_parseDevicesResult',{name:_name});case 15:

(0,_common.logDebug)('_parseDevicesResult',{deviceOnly:deviceOnly,isDevice:isDevice});
if(deviceOnly&&isDevice||!deviceOnly){
devices.push({
udid:words[0],
isDevice:isDevice,
isActive:true,
name:_name});

}return _context4.abrupt("return",
true);case 18:case"end":return _context4.stop();}}});})));case 8:if(!





avdsString){_context6.next=13;break;}
avdLines=avdsString.trim().split(/\r?\n/);
(0,_common.logDebug)('_parseDevicesResult',{avdLines:avdLines});_context6.next=13;return _regenerator.default.awrap(

Promise.all(avdLines.map(function _callee2(line){var avdDetails;return _regenerator.default.async(function _callee2$(_context5){while(1){switch(_context5.prev=_context5.next){case 0:


try{
avdDetails=getAvdDetails(c,line);
}catch(e){
(0,_common.logError)(e);
}

try{
(0,_common.logDebug)('_parseDevicesResult',{avdDetails:avdDetails});



_child_process.default.execSync("ps x | grep \"avd "+line+"\" | grep -v grep");
(0,_common.logDebug)('_parseDevicesResult - excluding running emulator');
}catch(e){
if(avdDetails){
devices.push(_objectSpread({
udid:'unknown',
isDevice:false,
isActive:false,
name:line},
avdDetails));

}
}case 2:case"end":return _context5.stop();}}});})));case 13:



(0,_common.logDebug)('_parseDevicesResult',{devices:devices});return _context6.abrupt("return",

Promise.all(devices.map(function(device){return getDeviceType(device,c);})).
then(function(devicesArray){return devicesArray.filter(function(device){var

platform=c.platform;
var matches=platform===_constants.ANDROID&&device.isTablet||platform===_constants.ANDROID_WEAR&&device.isWear||platform===_constants.ANDROID_TV&&device.isTV||platform===_constants.ANDROID&&device.isMobile;
(0,_common.logDebug)('getDeviceType - filter',{device:device,matches:matches,platform:platform});
return matches;
});}));case 15:case"end":return _context6.stop();}}});};


var _getDeviceProp=function _getDeviceProp(arr,prop){
for(var i=0;i<arr.length;i++){
var v=arr[i];
if(v&&v.includes(prop))return v.replace(prop,'');
}
return'';
};

var _askForNewEmulator=function _askForNewEmulator(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)('_askForNewEmulator');
var emuName=c.files.globalConfig.defaultTargets[platform];
var readlineInterface=readline.createInterface({
input:process.stdin,
output:process.stdout});

readlineInterface.question(
(0,_common.getQuestion)("Do you want ReNative to create new Emulator ("+_chalk.default.white(emuName)+") for you? (y) to confirm"),
function(v){
if(v.toLowerCase()==='y'){
readlineInterface.question((0,_common.getQuestion)('Input desired Android API version number'),function(v){
var apiVersion=v;
readlineInterface.question(
(0,_common.getQuestion)('Select device type: \n 1: Android Phone \n 2: Android TV \n 3: Android Wear \n'),
function(val){
switch(parseInt(val,10)){
case 1:
return _createEmulator(c,apiVersion,'google_apis',emuName);
case 2:
return _createEmulator(c,apiVersion,'android-tv',emuName);
case 3:
return _createEmulator(c,apiVersion,'android-wear',emuName);
default:
return reject('Wrong value entered');}

});

});
}else{
reject('Cannot find any active emulators');
}
});

});};

var _createEmulator=function _createEmulator(c,apiVersion,emuPlatform,emuName){
(0,_common.logTask)('_createEmulator');
return(0,_exec.execCLI)(c,_common.CLI_ANDROID_SDKMANAGER,"\"system-images;android-"+apiVersion+";"+emuPlatform+";x86\"").
then(function(){return(0,_exec.execCLI)(
c,
_common.CLI_ANDROID_AVDMANAGER,"create avd  -n "+
emuName+" -k \"system-images;android-"+apiVersion+";"+emuPlatform+";x86\" ");}).

catch(function(e){return(0,_common.logError)(e,true);});
};

var copyAndroidAssets=function copyAndroidAssets(c,platform){return new Promise(function(resolve){
(0,_common.logTask)('copyAndroidAssets');
if(!(0,_common.isPlatformActive)(c,platform,resolve))return;

var destPath=_path.default.join((0,_common.getAppFolder)(c,platform),'app/src/main/res');
var sourcePath=_path.default.join(c.paths.appConfigFolder,"assets/"+platform+"/res");
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath,destPath);
resolve();
});};exports.copyAndroidAssets=copyAndroidAssets;

var packageAndroid=function packageAndroid(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)('packageAndroid');var


entryFile=c.files.appConfigFile.platforms[platform].entryFile;

var outputFile;
if(platform===_constants.ANDROID_WEAR){
outputFile=entryFile;
}else{
outputFile='index.android';
}


var appFolder=(0,_common.getAppFolder)(c,platform);
(0,_exec.executeAsync)('react-native',[
'bundle',
'--platform',
'android',
'--dev',
'false',
'--assets-dest',
appFolder+"/app/src/main/res",
'--entry-file',
entryFile+".js",
'--bundle-output',
appFolder+"/app/src/main/assets/"+outputFile+".bundle"]).

then(function(){return resolve();}).
catch(function(e){return reject(e);});
});};exports.packageAndroid=packageAndroid;

var waitForEmulatorToBeReady=function waitForEmulatorToBeReady(c,emulator){return new Promise(function(resolve){
var attempts=0;
var maxAttempts=10;
var poll=setInterval(function(){
try{
var isBooting=_child_process.default.execSync(c.cli[_common.CLI_ANDROID_ADB]+" -s "+emulator+" shell getprop init.svc.bootanim").toString();
if(isBooting.includes('stopped')){
clearInterval(poll);
(0,_common.logDebug)('waitForEmulatorToBeReady - boot complete');
resolve(emulator);
}else{
attempts++;
console.log("Checking if emulator has booted up: attempt "+attempts+"/"+maxAttempts);
if(attempts===maxAttempts){
clearInterval(poll);
throw new Error('Can\'t connect to the running emulator. Try restarting it.');
}
}
}catch(e){
console.log("Checking if emulator has booted up: attempt "+attempts+"/"+maxAttempts);
attempts++;
if(attempts>maxAttempts){
clearInterval(poll);
throw new Error('Can\'t connect to the running emulator. Try restarting it.');
}
}
},CHECK_INTEVAL);
});};

var runAndroid=function runAndroid(c,platform,target){return new Promise(function(resolve,reject){
(0,_common.logTask)("runAndroid:"+platform+":"+target);

var bundleAssets=(0,_common.getConfigProp)(c,platform,'bundleAssets',false)===true;
var bundleIsDev=(0,_common.getConfigProp)(c,platform,'bundleIsDev',false)===true;

if(bundleAssets){
packageAndroid(c,platform,bundleIsDev).
then(function(){return _runGradle(c,platform);}).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
}else{
_runGradle(c,platform).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
}
});};exports.runAndroid=runAndroid;

var _runGradle=function _runGradle(c,platform){var target,devicesAndEmulators,activeDevices,inactiveDevices,askWhereToRun,foundDevice,device,dv;return _regenerator.default.async(function _runGradle$(_context8){while(1){switch(_context8.prev=_context8.next){case 0:
(0,_common.logTask)("_runGradle:"+platform);

target=c.program.target;if(!(

target&&_net.default.isIP(target))){_context8.next=5;break;}_context8.next=5;return _regenerator.default.awrap(
connectToWifiDevice(c,target));case 5:_context8.prev=5;_context8.next=8;return _regenerator.default.awrap(




_listAndroidTargets(c,false,false,c.program.device!==undefined));case 8:devicesAndEmulators=_context8.sent;_context8.next=14;break;case 11:_context8.prev=11;_context8.t0=_context8["catch"](5);return _context8.abrupt("return",

Promise.reject());case 14:

activeDevices=devicesAndEmulators.filter(function(d){return d.isActive;});
inactiveDevices=devicesAndEmulators.filter(function(d){return!d.isActive;});

askWhereToRun=function askWhereToRun(){var devicesString,choices,response,_devices,_devicesString,_choices,_response,dev;return _regenerator.default.async(function askWhereToRun$(_context7){while(1){switch(_context7.prev=_context7.next){case 0:if(!(
activeDevices.length===0&&inactiveDevices.length>0)){_context7.next=16;break;}

devicesString=composeDevicesString(inactiveDevices,true);
choices=devicesString;_context7.next=5;return _regenerator.default.awrap(
_inquirer.default.prompt([{
name:'chosenEmulator',
type:'list',
message:'What emulator would you like to start?',
choices:choices}]));case 5:response=_context7.sent;if(!

response.chosenEmulator){_context7.next=14;break;}_context7.next=9;return _regenerator.default.awrap(
launchAndroidSimulator(c,platform,response.chosenEmulator,true));case 9:_context7.next=11;return _regenerator.default.awrap(
_checkForActiveEmulator(c,platform));case 11:_devices=_context7.sent;_context7.next=14;return _regenerator.default.awrap(
_runGradleApp(c,platform,_devices));case 14:_context7.next=28;break;case 16:if(!(

activeDevices.length>1)){_context7.next=28;break;}
_devicesString=composeDevicesString(activeDevices,true);
_choices=_devicesString;_context7.next=21;return _regenerator.default.awrap(
_inquirer.default.prompt([{
name:'chosenEmulator',
type:'list',
message:'Where would you like to run your app?',
choices:_choices}]));case 21:_response=_context7.sent;if(!

_response.chosenEmulator){_context7.next=26;break;}
dev=activeDevices.find(function(d){return d.name===_response.chosenEmulator;});_context7.next=26;return _regenerator.default.awrap(
_runGradleApp(c,platform,dev));case 26:_context7.next=28;break;case 28:case"end":return _context7.stop();}}});};if(!








target){_context8.next=39;break;}
console.log('TCL: _runGradle -> devicesAndEmulators',devicesAndEmulators);
foundDevice=devicesAndEmulators.find(function(d){return d.udid.includes(target)||d.name.includes(target);});if(!
foundDevice){_context8.next=35;break;}if(!
foundDevice.isActive){_context8.next=26;break;}_context8.next=24;return _regenerator.default.awrap(
_runGradleApp(c,platform,foundDevice));case 24:_context8.next=33;break;case 26:_context8.next=28;return _regenerator.default.awrap(

launchAndroidSimulator(c,platform,foundDevice,true));case 28:_context8.next=30;return _regenerator.default.awrap(
_checkForActiveEmulator(c,platform));case 30:device=_context8.sent;_context8.next=33;return _regenerator.default.awrap(
_runGradleApp(c,platform,device));case 33:_context8.next=37;break;case 35:_context8.next=37;return _regenerator.default.awrap(


askWhereToRun());case 37:_context8.next=48;break;case 39:if(!(

activeDevices.length===1)){_context8.next=46;break;}

dv=activeDevices[0];
(0,_common.logInfo)("Found device "+dv.name+":"+dv.udid+"!");_context8.next=44;return _regenerator.default.awrap(
_runGradleApp(c,platform,dv));case 44:_context8.next=48;break;case 46:_context8.next=48;return _regenerator.default.awrap(

askWhereToRun());case 48:case"end":return _context8.stop();}}},null,null,[[5,11]]);};



var _checkForActiveEmulator=function _checkForActiveEmulator(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("_checkForActiveEmulator:"+platform);
var attempts=1;
var maxAttempts=10;
var running=false;
var poll=setInterval(function(){

if(!running){
running=true;
_listAndroidTargets(c,false,true,false).
then(function(v){
if(v.length>0){
(0,_common.logSuccess)("Found active emulator! "+_chalk.default.white(v[0].udid)+". Will use it");
clearInterval(poll);
resolve(v[0]);
}else{
running=false;
console.log("looking for active emulators: attempt "+attempts+"/"+maxAttempts);
attempts++;
if(attempts>maxAttempts){
clearInterval(poll);
reject('Could not find any active emulatros');



}
}
}).
catch(function(e){
clearInterval(poll);
(0,_common.logError)(e);
});
}
},CHECK_INTEVAL);
});};

var _checkSigningCerts=function _checkSigningCerts(c){return new Promise(function(resolve,reject){
(0,_common.logTask)('_checkSigningCerts');
var signingConfig=(0,_common.getConfigProp)(c,c.platform,'signingConfig','Debug');

if(signingConfig==='Release'&&!c.files.privateConfig){
(0,_common.logError)("You're attempting to "+c.command+" app in release mode but you have't configured your "+_chalk.default.white(c.paths.privateConfigPath)+" yet.");
(0,_common.askQuestion)('Do you want to configure it now? (y)').
then(function(v){
var sc={};
if(v==='y'){
(0,_common.askQuestion)("Paste asolute or relative path to "+_chalk.default.white(c.paths.privateConfigDir)+" of your existing "+_chalk.default.white('release.keystore')+" file.",sc,'storeFile').
then(function(){return(0,_common.askQuestion)('storePassword',sc,'storePassword');}).
then(function(){return(0,_common.askQuestion)('keyAlias',sc,'keyAlias');}).
then(function(){return(0,_common.askQuestion)('keyPassword',sc,'keyPassword');}).
then(function(){
(0,_common.finishQuestion)();
if(c.paths.privateConfigDir){
(0,_fileutils.mkdirSync)(c.paths.privateConfigDir);
c.files.privateConfig={
android:sc};

}
_fs.default.writeFileSync(c.paths.privateConfigPath,JSON.stringify(c.files.privateConfig,null,2));
(0,_common.logSuccess)("Successfully created private config file at "+_chalk.default.white(c.paths.privateConfigPath)+".");
resolve();
});
}else{
reject("You selected "+v+". Can't proceed");
}
}).catch(function(e){return reject(e);});
}else{
resolve();
}
});};

var _runGradleApp=function _runGradleApp(c,platform,device){return new Promise(function(resolve,reject){
(0,_common.logTask)("_runGradleApp:"+platform);

var signingConfig=(0,_common.getConfigProp)(c,platform,'signingConfig','Debug');
var appFolder=(0,_common.getAppFolder)(c,platform);
var bundleId=(0,_common.getConfigProp)(c,platform,'id');
var outputFolder=signingConfig==='Debug'?'debug':'release';var
arch=device.arch,name=device.name;

_shelljs.default.cd(""+appFolder);

_checkSigningCerts(c).
then(function(){return(0,_exec.executeAsync)(process.platform==='win32'?'gradlew.bat':'./gradlew',["assemble"+
signingConfig,
'-x',
'bundleReleaseJsAndAssets']);}).

then(function(){
var apkPath=_path.default.join(appFolder,"app/build/outputs/apk/"+outputFolder+"/app-"+outputFolder+".apk");
if(!_fs.default.existsSync(apkPath)){
apkPath=_path.default.join(appFolder,"app/build/outputs/apk/"+outputFolder+"/app-"+outputFolder+"-unsigned.apk");
}if(!_fs.default.existsSync(apkPath)){
apkPath=_path.default.join(appFolder,"app/build/outputs/apk/"+outputFolder+"/app-"+arch+"-"+outputFolder+".apk");
}
(0,_common.logInfo)("Installing "+apkPath+" on "+name);
return(0,_exec.executeAsync)(c.cli[_common.CLI_ANDROID_ADB],['-s',device.udid,'install','-r','-d','-f',apkPath]);
}).
then(function(){return device.isDevice&&platform!==_constants.ANDROID_WEAR?
(0,_exec.executeAsync)(c.cli[_common.CLI_ANDROID_ADB],['-s',device.udid,'reverse','tcp:8081','tcp:8081']):
Promise.resolve();}).
then(function(){return(0,_exec.executeAsync)(c.cli[_common.CLI_ANDROID_ADB],[
'-s',
device.udid,
'shell',
'am',
'start',
'-n',
bundleId+"/.MainActivity"]);}).

then(function(){return resolve();}).
catch(function(e){return reject(e);});
});};

var buildAndroid=function buildAndroid(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("buildAndroid:"+platform);

var appFolder=(0,_common.getAppFolder)(c,platform);
var signingConfig=(0,_common.getConfigProp)(c,platform,'signingConfig','Debug');

_shelljs.default.cd(""+appFolder);

_checkSigningCerts(c).
then(function(){return(0,_exec.executeAsync)(process.platform==='win32'?'gradlew.bat':'./gradlew',["assemble"+
signingConfig,
'-x',
'bundleReleaseJsAndAssets']);}).

then(function(){
(0,_common.logSuccess)("Your APK is located in "+_chalk.default.white(_path.default.join(appFolder,'app/build/outputs/apk/release'))+".");
resolve();
}).catch(function(e){return reject(e);});
});};exports.buildAndroid=buildAndroid;

var configureAndroidProperties=function configureAndroidProperties(c){return new Promise(function(resolve){
(0,_common.logTask)('configureAndroidProperties');

var localProperties=_path.default.join(c.paths.globalConfigFolder,'local.properties');
if(_fs.default.existsSync(localProperties)){
console.log('local.properties file exists!');
}else{
console.log('local.properties file missing! Creating one for you...');
}

_fs.default.writeFileSync(
localProperties,"#Generated by ReNative (https://renative.org)\nndk.dir="+

c.files.globalConfig.sdks.ANDROID_NDK+"\nsdk.dir="+
c.files.globalConfig.sdks.ANDROID_SDK);


resolve();
});};exports.configureAndroidProperties=configureAndroidProperties;

var configureGradleProject=function configureGradleProject(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("configureGradleProject:"+platform);

if(!(0,_common.isPlatformActive)(c,platform,resolve))return;



configureAndroidProperties(c,platform).
then(function(){return copyAndroidAssets(c,platform);}).
then(function(){return(0,_common.copyBuildsFolder)(c,platform);}).
then(function(){return configureProject(c,platform);}).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
});};exports.configureGradleProject=configureGradleProject;

var _injectPlugin=function _injectPlugin(c,plugin,key,pkg,pluginConfig){
var className=pkg?pkg.split('.').pop():null;
var packageParams='';
if(plugin.packageParams){
packageParams=plugin.packageParams.join(',');
}

var pathFixed=plugin.path?""+plugin.path:"node_modules/"+key+"/android";
var modulePath="../../"+pathFixed;
if(plugin.projectName){
pluginConfig.pluginIncludes+=", ':"+plugin.projectName+"'";
pluginConfig.pluginPaths+="project(':"+
plugin.projectName+"').projectDir = new File(rootProject.projectDir, '"+
modulePath+"')\n";
if(!plugin.skipImplementation){
if(plugin.implementation){
pluginConfig.pluginImplementations+=plugin.implementation+"\n";
}else{
pluginConfig.pluginImplementations+="    implementation project(':"+plugin.projectName+"')\n";
}
}
}else{
pluginConfig.pluginIncludes+=", ':"+key+"'";
pluginConfig.pluginPaths+="project(':"+key+"').projectDir = new File(rootProject.projectDir, '"+modulePath+"')\n";
if(!plugin.skipImplementation){
if(plugin.implementation){
pluginConfig.pluginImplementations+=plugin.implementation+"\n";
}else{
pluginConfig.pluginImplementations+="    implementation project(':"+key+"')\n";
}
}
}
if(plugin.activityImports instanceof Array){
plugin.activityImports.forEach(function(activityImport){

if(pluginConfig.pluginActivityImports.indexOf(activityImport)===-1){
pluginConfig.pluginActivityImports+="import "+activityImport+"\n";
}
});
}

if(plugin.activityMethods instanceof Array){
pluginConfig.pluginActivityMethods+='\n';
pluginConfig.pluginActivityMethods+=""+plugin.activityMethods.join('\n    ');
}

var mainActivity=plugin.mainActivity;
if(mainActivity){
if(mainActivity.createMethods instanceof Array){
pluginConfig.pluginActivityCreateMethods+='\n';
pluginConfig.pluginActivityCreateMethods+=""+mainActivity.createMethods.join('\n    ');
}

if(mainActivity.resultMethods instanceof Array){
pluginConfig.pluginActivityResultMethods+='\n';
pluginConfig.pluginActivityResultMethods+=""+mainActivity.resultMethods.join('\n    ');
}

if(mainActivity.imports instanceof Array){
mainActivity.imports.forEach(function(v){
pluginConfig.pluginActivityImports+="import "+v+"\n";
});
}

if(mainActivity.methods instanceof Array){
pluginConfig.pluginActivityMethods+='\n';
pluginConfig.pluginActivityMethods+=""+mainActivity.methods.join('\n    ');
}
}

if(pkg)pluginConfig.pluginImports+="import "+pkg+"\n";
if(className)pluginConfig.pluginPackages+=className+"("+packageParams+"),\n";

if(plugin.imports){
plugin.imports.forEach(function(v){
pluginConfig.pluginImports+="import "+v+"\n";
});
}

if(plugin.implementations){
plugin.implementations.forEach(function(v){
pluginConfig.pluginImplementations+="    implementation "+v+"\n";
});
}

if(plugin.mainApplicationMethods){
pluginConfig.mainApplicationMethods+="\n"+plugin.mainApplicationMethods+"\n";
}

var appBuildGradle=plugin['app/build.gradle'];
if(appBuildGradle){
if(appBuildGradle.apply){
appBuildGradle.apply.forEach(function(v){
pluginConfig.applyPlugin+="apply "+v+"\n";
});
}
}

if(plugin.afterEvaluate){
plugin.afterEvaluate.forEach(function(v){
pluginConfig.pluginAfterEvaluate+=" "+v+"\n";
});
}
_fixAndroidLegacy(c,pathFixed);
};

var _fixAndroidLegacy=function _fixAndroidLegacy(c,modulePath){
var buildGradle=_path.default.join(c.paths.projectRootFolder,modulePath,'build.gradle');

if(_fs.default.existsSync(buildGradle)){
(0,_common.logDebug)('FIX:',buildGradle);
(0,_common.writeCleanFile)(buildGradle,buildGradle,[
{pattern:" compile '",override:"  implementation '"},
{pattern:' compile "',override:'  implementation "'},
{pattern:' testCompile "',override:'  testImplementation "'},
{pattern:" provided '",override:"  compileOnly '"},
{pattern:' provided "',override:'  compileOnly "'},
{pattern:' compile fileTree',override:'  implementation fileTree'}]);

}
};

var configureProject=function configureProject(c,platform){return new Promise(function(resolve,reject){var _c$files$pluginConfig,_pluginConfigAndroid$,_pluginConfigAndroid$2,_c$files$permissionsC;
(0,_common.logTask)("configureProject:"+platform);

var appFolder=(0,_common.getAppFolder)(c,platform);
var appTemplateFolder=(0,_common.getAppTemplateFolder)(c,platform);

var gradlew=_path.default.join(appFolder,'gradlew');

if(!_fs.default.existsSync(gradlew)){
(0,_common.logWarning)("Looks like your "+_chalk.default.white(platform)+" platformBuild is misconfigured!. let's repair it.");
(0,_platform.createPlatformBuild)(c,platform).
then(function(){return configureGradleProject(c,platform);}).
then(function(){return resolve(c);}).
catch(function(e){return reject(e);});
return;
}

(0,_fileutils.copyFileSync)(_path.default.join(c.paths.globalConfigFolder,'local.properties'),_path.default.join(appFolder,'local.properties'));
(0,_fileutils.mkdirSync)(_path.default.join(appFolder,'app/src/main/assets'));
_fs.default.writeFileSync(_path.default.join(appFolder,'app/src/main/assets/index.android.bundle'),'{}');
_fs.default.chmodSync(gradlew,'755');


var pluginIncludes="include ':app'";
var pluginPaths='';
var pluginImports='';
var pluginPackages='MainReactPackage(),\n';
var pluginImplementations='';
var pluginAfterEvaluate='';
var pluginActivityImports='';
var pluginActivityMethods='';
var mainApplicationMethods='';
var applyPlugin='';
var pluginActivityCreateMethods='';
var pluginActivityResultMethods='';
var manifestApplication='';
var pluginConfig={
pluginIncludes:pluginIncludes,
pluginPaths:pluginPaths,
pluginImports:pluginImports,
pluginPackages:pluginPackages,
pluginImplementations:pluginImplementations,
pluginAfterEvaluate:pluginAfterEvaluate,
pluginActivityImports:pluginActivityImports,
pluginActivityMethods:pluginActivityMethods,
mainApplicationMethods:mainApplicationMethods,
applyPlugin:applyPlugin,
pluginActivityCreateMethods:pluginActivityCreateMethods,
pluginActivityResultMethods:pluginActivityResultMethods,
manifestApplication:manifestApplication};



(0,_pluginTools.parsePlugins)(c,function(plugin,pluginPlat,key){




_injectPlugin(c,pluginPlat,key,pluginPlat.package,pluginConfig);
});

pluginConfig.pluginPackages=pluginConfig.pluginPackages.substring(0,pluginConfig.pluginPackages.length-2);

var pluginConfigAndroid=((_c$files$pluginConfig=c.files.pluginConfig)==null?void 0:_c$files$pluginConfig.android)||{};


if(c.files.appConfigFile){
if(_fs.default.existsSync(c.paths.fontsConfigFolder)){
_fs.default.readdirSync(c.paths.fontsConfigFolder).forEach(function(font){
if(font.includes('.ttf')||font.includes('.otf')){
var key=font.split('.')[0];var
includedFonts=c.files.appConfigFile.common.includedFonts;
if(includedFonts){
if(includedFonts.includes('*')||includedFonts.includes(key)){
if(font){
var fontSource=_path.default.join(c.paths.projectConfigFolder,'fonts',font);
if(_fs.default.existsSync(fontSource)){
var fontFolder=_path.default.join(appFolder,'app/src/main/assets/fonts');
(0,_fileutils.mkdirSync)(fontFolder);
var fontDest=_path.default.join(fontFolder,font);
(0,_fileutils.copyFileSync)(fontSource,fontDest);
}else{
(0,_common.logWarning)("Font "+_chalk.default.white(fontSource)+" doesn't exist! Skipping.");
}
}
}
}
}
});
}
}


var debugSigning="\n    debug {\n        storeFile file('debug.keystore')\n        storePassword \"android\"\n        keyAlias \"androiddebugkey\"\n        keyPassword \"android\"\n    }";








pluginConfig.signingConfigs=debugSigning+"\n    release";

pluginConfig.localProperties='';
c.files.privateConfig=_getPrivateConfig(c,platform);

if(c.files.privateConfig&&c.files.privateConfig[platform]){
var keystorePath=c.files.privateConfig[platform].storeFile;
var keystorePathFull;
if(keystorePath){
if(keystorePath.startsWith('./')){
keystorePathFull=_path.default.join(c.files.privateConfig.parentFolder,keystorePath);
}else{
keystorePathFull=keystorePath;
}
}

if(_fs.default.existsSync(keystorePathFull)){
var genPropsPath=_path.default.join(appFolder,'keystore.properties');
_fs.default.writeFileSync(genPropsPath,"# auto generated by ReNative\nstoreFile="+
keystorePathFull+"\nkeyAlias="+
c.files.privateConfig[platform].keyAlias+"\nstorePassword="+
c.files.privateConfig[platform].storePassword+"\nkeyPassword="+
c.files.privateConfig[platform].keyPassword);

pluginConfig.signingConfigs=debugSigning+"\n            release {\n                storeFile file(keystoreProps['storeFile'])\n                storePassword keystoreProps['storePassword']\n                keyAlias keystoreProps['keyAlias']\n                keyPassword keystoreProps['keyPassword']\n            }";







pluginConfig.localProperties="\n          def keystorePropsFile = rootProject.file(\"keystore.properties\")\n          def keystoreProps = new Properties()\n          keystoreProps.load(new FileInputStream(keystorePropsFile))";



}else{
(0,_common.logWarning)("Your "+
_chalk.default.white(keystorePathFull)+" does not exist. You won't be able to make production releases without it!");

}
}


pluginConfig.buildTypes="\n    debug {\n        minifyEnabled false\n        proguardFiles getDefaultProguardFile('proguard-android-optimize.txt'), 'proguard-rules.pro'\n    }\n    release {\n        minifyEnabled false\n        proguardFiles getDefaultProguardFile('proguard-android.txt'), 'proguard-rules.pro'\n        signingConfig signingConfigs.release\n    }";










var isMultiApk=(0,_common.getConfigProp)(c,platform,'multipleAPKs',false)===true;

pluginConfig.multiAPKs='';
if(isMultiApk){
pluginConfig.multiAPKs="\n      ext.abiCodes = [\"armeabi-v7a\": 1, \"x86\": 2, \"arm64-v8a\": 3, \"x86_64\": 4]\n      import com.android.build.OutputFile\n\n      android.applicationVariants.all { variant ->\n        variant.outputs.each { output ->\n          def bavc = project.ext.abiCodes.get(output.getFilter(OutputFile.ABI))\n          if (bavc != null) {\n            output.versionCodeOverride = Integer.parseInt(Integer.toString(variant.versionCode) + Integer.toString(bavc))\n          }\n        }\n      }";











}


pluginConfig.splits='';
if(isMultiApk){
pluginConfig.splits="\n    splits {\n      abi {\n          reset()\n          enable true\n          include \"armeabi-v7a\", \"x86\", \"arm64-v8a\", \"x86_64\"\n          universalApk false\n      }\n    }\n";









}



pluginConfig.packagingOptions="\n    exclude 'META-INF/DEPENDENCIES.txt'\n    exclude 'META-INF/DEPENDENCIES'\n    exclude 'META-INF/dependencies.txt'\n    exclude 'META-INF/LICENSE.txt'\n    exclude 'META-INF/LICENSE'\n    exclude 'META-INF/license.txt'\n    exclude 'META-INF/LGPL2.1'\n    exclude 'META-INF/NOTICE.txt'\n    exclude 'META-INF/NOTICE'\n    exclude 'META-INF/notice.txt'\n    pickFirst 'lib/armeabi-v7a/libc++_shared.so'\n    pickFirst 'lib/x86_64/libc++_shared.so'\n    pickFirst 'lib/x86/libc++_shared.so'\n    pickFirst 'lib/arm64-v8a/libc++_shared.so'\n    pickFirst 'lib/arm64-v8a/libjsc.so'\n    pickFirst 'lib/x86_64/libjsc.so'";


















pluginConfig.compileOptions="\n    sourceCompatibility 1.8\n    targetCompatibility 1.8";





var manifestApplicationParams=(_pluginConfigAndroid$=pluginConfigAndroid.manifest)==null?void 0:(_pluginConfigAndroid$2=_pluginConfigAndroid$.application)==null?void 0:_pluginConfigAndroid$2.parameters;
if(manifestApplicationParams){
manifestApplicationParams.forEach(function(v){
pluginConfig.manifestApplication+="     "+v+"\n";
});
}

(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,'settings.gradle'),_path.default.join(appFolder,'settings.gradle'),[
{pattern:'{{PLUGIN_INCLUDES}}',override:pluginConfig.pluginIncludes},
{pattern:'{{PLUGIN_PATHS}}',override:pluginConfig.pluginPaths}]);



pluginConfig.minSdkVersion=(0,_common.getConfigProp)(c,platform,'minSdkVersion',21);
pluginConfig.targetSdkVersion=(0,_common.getConfigProp)(c,platform,'targetSdkVersion',28);
pluginConfig.compileSdkVersion=(0,_common.getConfigProp)(c,platform,'compileSdkVersion',28);
pluginConfig.supportLibVersion=(0,_common.getConfigProp)(c,platform,'supportLibVersion','28.0.0');
pluginConfig.buildToolsVersion=(0,_common.getConfigProp)(c,platform,'buildToolsVersion','28.0.0');


(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,'app/build.gradle'),_path.default.join(appFolder,'app/build.gradle'),[
{pattern:'{{PLUGIN_APPLY}}',override:pluginConfig.applyPlugin},
{pattern:'{{APPLICATION_ID}}',override:(0,_common.getAppId)(c,platform)},
{pattern:'{{VERSION_CODE}}',override:(0,_common.getAppVersionCode)(c,platform)},
{pattern:'{{VERSION_NAME}}',override:(0,_common.getAppVersion)(c,platform)},
{pattern:'{{PLUGIN_IMPLEMENTATIONS}}',override:pluginConfig.pluginImplementations},
{pattern:'{{PLUGIN_AFTER_EVALUATE}}',override:pluginConfig.pluginAfterEvaluate},
{pattern:'{{PLUGIN_SIGNING_CONFIGS}}',override:pluginConfig.signingConfigs},
{pattern:'{{PLUGIN_SPLITS}}',override:pluginConfig.splits},
{pattern:'{{PLUGIN_PACKAGING_OPTIONS}}',override:pluginConfig.packagingOptions},
{pattern:'{{PLUGIN_BUILD_TYPES}}',override:pluginConfig.buildTypes},
{pattern:'{{PLUGIN_MULTI_APKS}}',override:pluginConfig.multiAPKs},
{pattern:'{{MIN_SDK_VERSION}}',override:pluginConfig.minSdkVersion},
{pattern:'{{TARGET_SDK_VERSION}}',override:pluginConfig.targetSdkVersion},
{pattern:'{{COMPILE_SDK_VERSION}}',override:pluginConfig.compileSdkVersion},
{pattern:'{{PLUGIN_COMPILE_OPTIONS}}',override:pluginConfig.compileOptions},
{pattern:'{{PLUGIN_LOCAL_PROPERTIES}}',override:pluginConfig.localProperties}]);


(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,'build.gradle'),_path.default.join(appFolder,'build.gradle'),[
{pattern:'{{COMPILE_SDK_VERSION}}',override:pluginConfig.compileSdkVersion},
{pattern:'{{SUPPORT_LIB_VERSION}}',override:pluginConfig.supportLibVersion},
{pattern:'{{BUILD_TOOLS_VERSION}}',override:pluginConfig.buildToolsVersion}]);


var activityPath='app/src/main/java/rnv/MainActivity.kt';
(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,activityPath),_path.default.join(appFolder,activityPath),[
{pattern:'{{APPLICATION_ID}}',override:(0,_common.getAppId)(c,platform)},
{pattern:'{{PLUGIN_ACTIVITY_IMPORTS}}',override:pluginConfig.pluginActivityImports},
{pattern:'{{PLUGIN_ACTIVITY_METHODS}}',override:pluginConfig.pluginActivityMethods},
{pattern:'{{PLUGIN_ON_CREATE}}',override:pluginConfig.pluginActivityCreateMethods},
{pattern:'{{PLUGIN_ON_ACTIVITY_RESULT}}',override:pluginConfig.pluginActivityResultMethods}]);


var applicationPath='app/src/main/java/rnv/MainApplication.kt';
(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,applicationPath),_path.default.join(appFolder,applicationPath),[
{pattern:'{{APPLICATION_ID}}',override:(0,_common.getAppId)(c,platform)},
{pattern:'{{ENTRY_FILE}}',override:(0,_common.getEntryFile)(c,platform)},
{pattern:'{{PLUGIN_IMPORTS}}',override:pluginConfig.pluginImports},
{pattern:'{{PLUGIN_PACKAGES}}',override:pluginConfig.pluginPackages},
{pattern:'{{PLUGIN_METHODS}}',override:pluginConfig.mainApplicationMethods}]);


var splashPath='app/src/main/java/rnv/SplashActivity.kt';
(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,splashPath),_path.default.join(appFolder,splashPath),[
{pattern:'{{APPLICATION_ID}}',override:(0,_common.getAppId)(c,platform)}]);


var stringsPath='app/src/main/res/values/strings.xml';
(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,stringsPath),_path.default.join(appFolder,stringsPath),[
{pattern:'{{APP_TITLE}}',override:(0,_common.getAppTitle)(c,platform)}]);


var prms='';var
permissions=c.files.appConfigFile.platforms[platform].permissions;
var configPermissions=(_c$files$permissionsC=c.files.permissionsConfig)==null?void 0:_c$files$permissionsC.permissions;

if(permissions&&configPermissions){
var platPerm=configPermissions[platform]?platform:'android';
var pc=configPermissions[platPerm];
if(permissions[0]==='*'){
for(var k in pc){
prms+="\n   <uses-permission android:name=\""+pc[k].key+"\" />";
}
}else{
permissions.forEach(function(v){
if(pc[v]){
prms+="\n   <uses-permission android:name=\""+pc[v].key+"\" />";
}
});
}
}

var manifestFile='app/src/main/AndroidManifest.xml';
(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,manifestFile),_path.default.join(appFolder,manifestFile),[
{pattern:'{{APPLICATION_ID}}',override:(0,_common.getAppId)(c,platform)},
{pattern:'{{PLUGIN_MANIFEST}}',override:prms},
{pattern:'{{PLUGIN_MANIFEST_APPLICATION}}',override:pluginConfig.manifestApplication}]);



var pluginGradleProperties='';

var gradleProps=pluginConfigAndroid['gradle.properties'];
if(gradleProps){
for(var key in gradleProps){
pluginGradleProperties+=key+"="+gradleProps[key]+"\n";
}
}
var gradleProperties='gradle.properties';
(0,_common.writeCleanFile)(_path.default.join(appTemplateFolder,gradleProperties),_path.default.join(appFolder,gradleProperties),[
{pattern:'{{PLUGIN_GRADLE_PROPERTIES}}',override:pluginGradleProperties}]);


resolve();
});};

var _getPrivateConfig=function _getPrivateConfig(c,platform){
var privateConfigFolder=_path.default.join(c.paths.globalConfigFolder,c.files.projectPackage.name,c.files.appConfigFile.id);
var appConfigSPP=c.files.appConfigFile.platforms[platform]?c.files.appConfigFile.platforms[platform].signingPropertiesPath:null;
var appConfigSPPClean=appConfigSPP?appConfigSPP.replace('{globalConfigFolder}',c.paths.globalConfigFolder):null;
var privateConfigPath=appConfigSPPClean||_path.default.join(privateConfigFolder,'config.private.json');
c.paths.privateConfigPath=privateConfigPath;
c.paths.privateConfigDir=privateConfigPath.replace('/config.private.json','');
if(_fs.default.existsSync(privateConfigPath)){
try{
var output=JSON.parse(_fs.default.readFileSync(privateConfigPath));
output.parentFolder=c.paths.privateConfigDir;
output.path=privateConfigPath;
(0,_common.logInfo)("Found "+
_chalk.default.white(privateConfigPath)+". Will use it for production releases!");

return output;
}catch(e){
(0,_common.logError)(e);
return null;
}
}else{
(0,_common.logWarning)("You're missing "+
_chalk.default.white(privateConfigPath)+" for this app: . You won't be able to make production releases without it!");

return null;
}
};


var runAndroidLog=function runAndroidLog(c){return new Promise(function(){
var filter=c.program.filter||'';
var child=_child_process.default.spawn(c.cli[_common.CLI_ANDROID_ADB],['logcat']);

child.stdout.on('data',function(data){
var d=data.toString().split('\n');
d.forEach(function(v){
if(v.includes(' E ')&&v.includes(filter)){
console.log(_chalk.default.red(v));
}else if(v.includes(' W ')&&v.includes(filter)){
console.log(_chalk.default.yellow(v));
}else if(v.includes(filter)){
console.log(v);
}
});
});
});};exports.runAndroidLog=runAndroidLog;